#!/bin/sh

# run all rules in calls.dat/ for each CALL node

get_subtrees()
{
	awk -v "pattern=$1" -v "reqnum=$2" '
		(prefix != "") {
			if ($0 ~ prefix) {
				if ((reqnum == "") || (reqnum == num))
					print $0
				next
			}
			prefix=""
		}
		($0 ~ "^ *" pattern) {
			num++
			if ((reqnum == "") || (reqnum == num)) {
				prefix=$0
				sub("[^ ].*", "", prefix)
				prefix="^" prefix
				print $0
			}
		}
	'
}

run_rule()
{
	awk -v "name=$1" -v "loc=$3" -v "output=$4" '
		function chkout(flag) {
			if (output ~ flag)
				copy = 1;
		}
		/^@name/ {
			pattern=$0
			sub("^@name[ 	]*", "", pattern)
			if (!(name ~ pattern))
				exit
		}
		/^@/ {
			if (copy) {
				print ""
				copy = 0
			}
		}
		(copy) {
			if (loc != "") {
				print loc
				loc=""
			}
			print $0
		}

		/^@description/ { chkout("d"); }
		/^@short/       { chkout("[ds]"); }
		/^@scconfig/    { chkout("c"); }
		/^@libporty/    { chkout("l"); }
	'
}

run_all()
{
	for rule in $RULESD/calls.dat/*
	do
		if test -f "$rule"
		then
			run_rule "$1" "$2" "$3" "d" < $rule
		fi
	done
}

src=`cat`
num=1
while true
do
	call=`echo "$src" | get_subtrees "CALL " "$num"`
	if test -z "$call"
	then
		break
	fi
#	echo "# $num"
#	echo "$call"
	num=`expr $num + 1`
	name=`echo $call | awk '{print $2; exit}'`
	loc=`echo $call | awk '{print $3; exit}'`
	run_all "$name" "$call" "$loc"
done

